OGRE: Ogre::StaticFaceGroup Struct Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::StaticFaceGroup Struct Reference

Collectes a group of static ie immovable faces together which have common properties like the material they use, the plane they lie on. More...

`#include <OgreStaticFaceGroup.h>`

List of all members.

## Public Attributes

FaceGroupType | fType
bool | isSky
| Is this a sky surface?
int | vertexStart
| Index into a buffer containing vertex definitions.
int | numVertices
| The range of vertices in the buffer this facegroup references.
int | elementStart
| Index into a buffer containing vertex indices.
int | numElements
| The number of vertex indices.
int | materialHandle
| Handle to material used by this group.
Plane | plane
PatchSurface * | patchSurf
| Patch surface (only applicable when fType = FGT_PATCH).

## Friends

_OgreExport friend std::ostream & | operator<< (std::ostream &o, const StaticFaceGroup &s)

## Detailed Description

Collectes a group of static ie immovable faces together which have common properties like the material they use, the plane they lie on.

Remarks:
  Whilst for discrete geometry (i.e. movable objects) groups of faces are held in the SubMesh class, for immovable objects like scenery there needs to ba little more flexibility in the grouping since the group is likely to be a small part of a huge set of geometry. In addition, because the faces are unmoving certain optimisations can be performed, e.g. precalculating a world-coordinate bounding box and normal.

  Exactly how this class is used depends on the format of the large static geometry used in the level. An example would be the use of this class in the BspNode class for indoor levels. For flexibility and efficiency, it is not assumed that this class holds details of the vertices itself, or in fact that it holds the vertex indices itself. Everything is manipulated via pointers so if you want this class to point into a block of geometry data it can.

Definition at line 64 of file OgreStaticFaceGroup.h.

## Friends And Related Function Documentation

_OgreExport friend std::ostream& operator<< | ( | std::ostream & | o,
|  | const StaticFaceGroup & | s
| ) | `[friend]`

| Definition at line 108 of file OgreStaticFaceGroup.h.

## Member Data Documentation

int Ogre::StaticFaceGroup::elementStart

Index into a buffer containing vertex indices.

This buffer may be individual to this group or shared for memory allocation efficiency.The vertex indexes are relative the the mVertexStart pointer, not to the start of the large-level buffer, allowing simple reindexing when copying data into rendering buffers. This is only applicable to FGT_FACE_LIST face group types.

Definition at line 89 of file OgreStaticFaceGroup.h.

FaceGroupType Ogre::StaticFaceGroup::fType

| Definition at line 66 of file OgreStaticFaceGroup.h.

bool Ogre::StaticFaceGroup::isSky

| Is this a sky surface? Definition at line 69 of file OgreStaticFaceGroup.h.

int Ogre::StaticFaceGroup::materialHandle

| Handle to material used by this group. Note the use of the material handle rather than the material name - this is for efficiency since there will be many of these. Definition at line 100 of file OgreStaticFaceGroup.h.

int Ogre::StaticFaceGroup::numElements

| The number of vertex indices. This is only applicable to FGT_FACE_LIST face group types. Definition at line 94 of file OgreStaticFaceGroup.h.

int Ogre::StaticFaceGroup::numVertices

| The range of vertices in the buffer this facegroup references. This is really for copying purposes only, so that we know which subset of vertices to copy from our large-level buffer into the rendering buffer. Definition at line 80 of file OgreStaticFaceGroup.h.

PatchSurface* Ogre::StaticFaceGroup::patchSurf

| Patch surface (only applicable when fType = FGT_PATCH). Definition at line 105 of file OgreStaticFaceGroup.h.

Plane Ogre::StaticFaceGroup::plane

| Definition at line 102 of file OgreStaticFaceGroup.h.

int Ogre::StaticFaceGroup::vertexStart

| Index into a buffer containing vertex definitions. Because we're dealing with subsets of large levels this is likely to be part-way through a huge vertex buffer. Definition at line 74 of file OgreStaticFaceGroup.h.

The documentation for this struct was generated from the following file:

- OgreStaticFaceGroup.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:04 2008